/*
 * AnalyseDeSon.java
 *
 * Created on 2 octobre 2006, 12:56
 */

package AnaSon;



import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioFormat.Encoding;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.Line;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.TargetDataLine;
import javax.swing.JFileChooser;
import javax.swing.JFrame;

interface constantes {
    public final boolean debug=false;
    public final int FIN_NOTE=1;// les fins de notes sont classees avant les debuts
    public final int DEB_NOTE=2;
    public final int size_lut_sin_cos=2048;
    public final int SHIFT_CMPT_TEMPS=15;
    public final int COEFF_CMPT_TEMPS=(1<<SHIFT_CMPT_TEMPS);
    public final int MASK_CMPT_TEMPS=size_lut_sin_cos*COEFF_CMPT_TEMPS-1;
    public final int NPol=4; // polynomes de degre 4 au maximum
    public final int NB_DECIM_MAX=10; // 10 decimations au maximum
    public final int   Mask_SeuilMod2=1    ;/* Masque Pour Indiquer Test sur Module Pas Passe */
    public final int   Mask_SeuilF=2       ;
    public final int   Mask_SeuilDeltaF=4  ; /* Masque Pour Indiquer Test DeltaF Pas Passe Sur TrvOK */
    public final int   Mask_SeuilF_MOINS_FINI=8  ; /* Masque Pour Indiquer Test DeltaF Pas Passe Sur TrvOK */
    public final int Mask_TEMPS_MAXI_DEPASSE=16;// indique duree max de piste depassee
    public final int Mask_NOT_IN_INTERVAL=32;// indique duree max de piste depassee
    public final int BIG_ENDIAN=0;
    public final int LOW_ENDIAN=1;
    public final int FORMAT_ENDIAN=2;

    public final int NB_POIDS_RELATIFS=2;
    public final float SEUIL_RELATIF_POIDS_DELTAF=0.001f*0.2f;
    
}
class StrVal{
    String str;
    float val;
    public StrVal() {
        
    }

    public boolean SetNameAndValue(String SChoix) {
       int i=str.indexOf(SChoix);
       if (i<0) return false;
       String SValue=str.substring(i+SChoix.length());
       int j=SValue.indexOf("\n");
       if (j<0 ) return false;
       
       SValue=SValue.substring(0,j+1);
       SValue=SValue.trim();
       val =Float.parseFloat(SValue);
       return true;
    }
}
/**
 *
 * @author  ygorra
 */
public class AnalyseDeSon extends javax.swing.JFrame {
    // Codage format dans jComboBoxEndian
    public int CHOIX_BIG_ENDIAN;
    
    public float F_ECH;
    public int LGN_BUF;
    public float F_MINI=50f;
    public float F_MAXI=3000f;
    public float F_MAXI_A_GARDER=3000f;
    public float F_LA=440f;
    /* VARIABLES RENVOYEES PAR INIT_CONTEXTE  */
    
    int NB_CEL_BES  =4    ;   // Word    ;/*=2         ;*/
    int NB_CEL_BUT  =4    ;   // Word    ;/*=2         ;*/
    int NB_FILTRES  =10    ;   // Byte    ;/*= 6        ;*/
    double DELTAF_DERIV =0.0025;      // Double  ;/*=0.0025    ;*/
    float SEUIL_MODU    =5.0f;     // Single ;/*= 10.0      ;*/
    float SEUIL_MOD2_RELATIVE=0.03f*0.03f; // Seuil relatif / Module maxi
    float SEUIL_PLUS_DERIVF= 1.5f;  // Single ;/* 1.5 */
    float SEUIL_MOINS_DERIVF= 0.5f; // Single ;/* 0.5 */
    
    float TEMPS_MINI_NB_OK=0.05f;
    float SEUIL_NB_OK_RELATIVE_RETARD_GROUPE=1f;
    
    float TEMPS_MINI_NB_ATTENTE=0.025f;
    float SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE=0.5f;
    
    float TEMPS_MINI_PREMIER_NB_OK=0.05f;//unused
    float SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE=2f;//unused
    
    
    float SEUIL_W_INST_RELATIVE_6DB=3.0f;
    float SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS=0.2f;
    float SEUIL_W_ATTENTE_RELATIVE_DEMI_TON=0.5f;
    // parametres de regroupement
    float  SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON=0.5f;
    // les notes dont le recouvrement temporel est < 75% de la largeur
    // ne sont pas considerees synchrones
    float  COEFF_RECOUVREMENT_NOTES_SYNCHRONES=0.75f;
    // les notes dont l'ecart est superieur a 0.5demi-tons
    // ne peuvent pas etre regroupees
    
    float  SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON=0.5f;
    // les notes dont l'ecart temporel 0.05s
    // ne peuvent pas etre regroupees
    float  SEUIL_TEMPS_NOTES_ASYNCHRONES=0.05f;

// INTERVALLES    
 
    float SEUIL_DUREE_MIN_INTERVAL_S=0.3f;// duree min intervalle apres regroupement,pour validation
//ne pas prendre en compte les notes disparaissant  moins de 0.03s apres le debut de l'evt'
    float SEUIL_DISPARITION_NOTE_PREC_S=0.2f;   // cale pour la voix
//regrouper les creations d'evts pour piste appparaissant successivement en moins de 0.03s

    float SEUIL_APPARITION_HMS_S=0.1f;
    int NB_PISTES_MIN_INTERVAL=1000;
    int NB_TRACK_ENERGY=0; // desactive
    int NB_TRACK_VALID_NOTE=1; // desactive
    float SEUIL_TEMPS_INTERFERENCES_S=0f;//desactive
    float SEUIL_MOD2_RELATIVE_FOR_NOTES=0.05f;
    float SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS=0.05f*0.05f;
//    public boolean running;
    public int nb_buffer;
    public     long startTime;
    public     long stopTime;
    public TargetDataLine line;
    
    public ContexteFlts glob_Contexte;
    
    private String system_exploitation="linux";
    
    boolean stocke_data_wav=false;
    /** Creates new form AnalyseDeSon */
    public AnalyseDeSon() {
        initComponents();
        this.jComboBoxEndian.setSelectedIndex(constantes.BIG_ENDIAN);
        CHOIX_BIG_ENDIAN=this.jComboBoxEndian.getSelectedIndex();
        F_ECH=(float)22050.0;
        LGN_BUF=2048;
        F_MINI=50.0f;
        F_MAXI=4000.0f;
        F_MAXI_A_GARDER=4000f;
        F_LA=440.0f;
        this.jButtonAccordeur.setText("Accordeur, LA4 = "+String.valueOf(Math.round(this.F_LA))+"Hertz");
        
        //    TEMPS_MINI=0.1;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jComboBoxsystem_exploitation = new javax.swing.JComboBox();
        jButtonFrequences = new javax.swing.JButton();
        jButtonParametres = new javax.swing.JButton();
        jButtonParametresNotes = new javax.swing.JButton();
        jComboBoxEndian = new javax.swing.JComboBox();
        jPanelDiapason = new javax.swing.JPanel();
        jButtonAccordeur = new javax.swing.JButton();
        jButtonSound2Scores = new javax.swing.JButton();
        jButtonTestFichiers = new javax.swing.JButton();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        openMenuItem = new javax.swing.JMenuItem();
        saveMenuItem = new javax.swing.JMenuItem();
        saveAsMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        editMenu = new javax.swing.JMenu();
        cutMenuItem = new javax.swing.JMenuItem();
        copyMenuItem = new javax.swing.JMenuItem();
        pasteMenuItem = new javax.swing.JMenuItem();
        deleteMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        contentsMenuItem = new javax.swing.JMenuItem();
        aboutMenuItem = new javax.swing.JMenuItem();

        getContentPane().setLayout(new java.awt.GridLayout(2, 2));

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridLayout(5, 0));

        jPanel1.setBackground(new java.awt.Color(0, 153, 51));
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Parametres"));
        jComboBoxsystem_exploitation.setBackground(new java.awt.Color(255, 255, 255));
        jComboBoxsystem_exploitation.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "linux", "windows" }));
        jComboBoxsystem_exploitation.setToolTipText("used by getFirstGoodMixerTargetDataline (the only one system dependent routine)");
        jComboBoxsystem_exploitation.setBorder(javax.swing.BorderFactory.createTitledBorder("Systeme d'exploitation"));
        jComboBoxsystem_exploitation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxsystem_exploitationActionPerformed(evt);
            }
        });

        jPanel1.add(jComboBoxsystem_exploitation);

        jButtonFrequences.setText("Reglage Frequences");
        jButtonFrequences.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonFrequencesActionPerformed(evt);
            }
        });

        jPanel1.add(jButtonFrequences);

        jButtonParametres.setText("Parametres avances ( bon courage..)");
        jButtonParametres.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonParametresActionPerformed(evt);
            }
        });

        jPanel1.add(jButtonParametres);

        jButtonParametresNotes.setText("Parametres des notes");
        jButtonParametresNotes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonParametresNotesActionPerformed(evt);
            }
        });

        jPanel1.add(jButtonParametresNotes);

        jComboBoxEndian.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "BigEndian => [poids faible,poids fort]", "LowEndian => [poids fort,poids faible]", "Faire Confiance au format Audio" }));
        jComboBoxEndian.setBorder(javax.swing.BorderFactory.createTitledBorder("Codage des donnees Audio"));
        jComboBoxEndian.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxEndianActionPerformed(evt);
            }
        });

        jPanel1.add(jComboBoxEndian);

        getContentPane().add(jPanel1);

        jPanelDiapason.setLayout(new java.awt.GridLayout(3, 1));

        jPanelDiapason.setBackground(new java.awt.Color(0, 204, 204));
        jPanelDiapason.setBorder(javax.swing.BorderFactory.createTitledBorder("Applications"));
        jButtonAccordeur.setText("Accordeur (LA )");
        jButtonAccordeur.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAccordeurActionPerformed(evt);
            }
        });

        jPanelDiapason.add(jButtonAccordeur);

        jButtonSound2Scores.setText("Traduit Son->Notes");
        jButtonSound2Scores.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSound2ScoresActionPerformed(evt);
            }
        });

        jPanelDiapason.add(jButtonSound2Scores);

        jButtonTestFichiers.setText("Analyser Fichier Wav");
        jButtonTestFichiers.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonTestFichiersTesterFichierWavActionPerformed(evt);
            }
        });

        jPanelDiapason.add(jButtonTestFichiers);

        getContentPane().add(jPanelDiapason);

        fileMenu.setText("File");
        openMenuItem.setLabel("charger fichier de parametres");
        openMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(openMenuItem);

        saveMenuItem.setLabel("Sauver Parametres");
        saveMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(saveMenuItem);

        saveAsMenuItem.setText("Save As ...");
        fileMenu.add(saveAsMenuItem);

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        editMenu.setText("Edit");
        cutMenuItem.setText("Cut");
        editMenu.add(cutMenuItem);

        copyMenuItem.setText("Copy");
        editMenu.add(copyMenuItem);

        pasteMenuItem.setText("Paste");
        editMenu.add(pasteMenuItem);

        deleteMenuItem.setText("Delete");
        editMenu.add(deleteMenuItem);

        menuBar.add(editMenu);

        helpMenu.setText("Help");
        contentsMenuItem.setText("Contents");
        helpMenu.add(contentsMenuItem);

        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });

        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        pack();
    }// </editor-fold>//GEN-END:initComponents
     
    private void getParametersFromString(String Name) {

       StrVal NameValue=new StrVal();
       NameValue.str=Name;
       if (NameValue.SetNameAndValue("CHOIX_BIG_ENDIAN")) CHOIX_BIG_ENDIAN = (int) Math.round(NameValue.val);
       if (NameValue.SetNameAndValue("F_ECH")) F_ECH = NameValue.val;
       if (NameValue.SetNameAndValue("F_MINI")) F_MINI = NameValue.val;
       if (NameValue.SetNameAndValue("F_MAXI")) F_MAXI = NameValue.val;
       if (NameValue.SetNameAndValue("F__MAXI_A_GARDER")) F_MAXI_A_GARDER = NameValue.val;
       if (NameValue.SetNameAndValue("F_LA")) F_LA = NameValue.val;
       if (NameValue.SetNameAndValue("NB_CEL_BES")) NB_CEL_BES =  (int) Math.round(NameValue.val);
       if (NameValue.SetNameAndValue("NB_CEL_BUT")) NB_CEL_BUT =  (int) Math.round(NameValue.val);
       if (NameValue.SetNameAndValue("NB_FILTRES")) NB_FILTRES =  (int) Math.round(NameValue.val);
       if (NameValue.SetNameAndValue("DELTAF_DERIV")) DELTAF_DERIV = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_MODU")) SEUIL_MODU = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_MOD2_RELATIVE")) SEUIL_MOD2_RELATIVE = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_PLUS_DERIVF")) SEUIL_PLUS_DERIVF = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_MOINS_DERIVF")) SEUIL_MOINS_DERIVF = NameValue.val;
       if (NameValue.SetNameAndValue("TEMPS_MINI_NB_OK")) TEMPS_MINI_NB_OK = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_NB_OK_RELATIVE_RETARD_GROUPE")) SEUIL_NB_OK_RELATIVE_RETARD_GROUPE = NameValue.val;
       if (NameValue.SetNameAndValue("TEMPS_MINI_NB_ATTENTE")) TEMPS_MINI_NB_ATTENTE = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE")) SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE = NameValue.val;
       if (NameValue.SetNameAndValue("TEMPS_MINI_PREMIER_NB_OK")) TEMPS_MINI_PREMIER_NB_OK = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE")) SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_W_INST_RELATIVE_6DB")) SEUIL_W_INST_RELATIVE_6DB = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS")) SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_W_ATTENTE_RELATIVE_DEMI_TON")) SEUIL_W_ATTENTE_RELATIVE_DEMI_TON = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON")) SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON = NameValue.val;
       if (NameValue.SetNameAndValue("COEFF_RECOUVREMENT_NOTES_SYNCHRONES")) COEFF_RECOUVREMENT_NOTES_SYNCHRONES = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON")) SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_TEMPS_NOTES_ASYNCHRONES")) SEUIL_TEMPS_NOTES_ASYNCHRONES = NameValue.val;
       if (NameValue.SetNameAndValue("DUREE_MIN_INTERVAL_S")) SEUIL_DUREE_MIN_INTERVAL_S = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_DISPARITION_NOTE_PREC_S")) SEUIL_DISPARITION_NOTE_PREC_S = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_APPARITION_HMS_S")) SEUIL_APPARITION_HMS_S = NameValue.val;
       if (NameValue.SetNameAndValue("SEUIL_TEMPS_INTERFERENCES_S")) SEUIL_TEMPS_INTERFERENCES_S = NameValue.val;
        if (NameValue.SetNameAndValue("SEUIL_MOD2_RELATIVE_FOR_NOTES")) SEUIL_MOD2_RELATIVE_FOR_NOTES = NameValue.val;
        if (NameValue.SetNameAndValue("SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS")) SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS = NameValue.val;
      if (NameValue.SetNameAndValue("NB_PISTES_MIN_INTERVAL")) NB_PISTES_MIN_INTERVAL =  (int) Math.round(NameValue.val);
       if (NameValue.SetNameAndValue("NB_TRACK_VALID_NOTE")) NB_TRACK_VALID_NOTE =  (int) Math.round(NameValue.val);
       if (NameValue.SetNameAndValue("system_exploitation")){
           int sys_exp=(int) Math.round(NameValue.val);
           this.jComboBoxsystem_exploitation.setSelectedIndex(sys_exp);
           this.system_exploitation=(String)jComboBoxsystem_exploitation.getSelectedItem();
       }
    }
    private String getStringFromParameters() {
    String Name="";
    Name=Name+"CHOIX_BIG_ENDIAN "+String.valueOf(CHOIX_BIG_ENDIAN)+"\n";
    Name=Name+"F_ECH "+String.valueOf(F_ECH)+"\n";
    Name=Name+"F_MINI "+String.valueOf(F_MINI)+"\n";
    Name=Name+"F_MAXI "+String.valueOf(F_MAXI)+"\n";
    Name=Name+"F__MAXI_A_GARDER "+String.valueOf(F_MAXI_A_GARDER)+"\n";
    Name=Name+"F_LA "+String.valueOf(F_LA)+"\n";
    Name=Name+"NB_CEL_BES "+String.valueOf(NB_CEL_BES)+"\n";
    Name=Name+"NB_CEL_BUT "+String.valueOf(NB_CEL_BUT)+"\n";
    Name=Name+"NB_FILTRES "+String.valueOf(NB_FILTRES)+"\n";
    Name=Name+"DELTAF_DERIV "+String.valueOf(DELTAF_DERIV)+"\n";
    Name=Name+"SEUIL_MODU "+String.valueOf(SEUIL_MODU)+"\n";
    Name=Name+"SEUIL_MOD2_RELATIVE "+String.valueOf(SEUIL_MOD2_RELATIVE)+"\n";
    Name=Name+"SEUIL_PLUS_DERIVF "+String.valueOf(SEUIL_PLUS_DERIVF)+"\n";
    Name=Name+"SEUIL_MOINS_DERIVF "+String.valueOf(SEUIL_MOINS_DERIVF)+"\n";
    Name=Name+"TEMPS_MINI_NB_OK "+String.valueOf(TEMPS_MINI_NB_OK)+"\n";
    Name=Name+"SEUIL_NB_OK_RELATIVE_RETARD_GROUPE "+String.valueOf(SEUIL_NB_OK_RELATIVE_RETARD_GROUPE)+"\n";
    Name=Name+"TEMPS_MINI_NB_ATTENTE "+String.valueOf(TEMPS_MINI_NB_ATTENTE)+"\n";
    Name=Name+"SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE "+String.valueOf(SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE)+"\n";
    Name=Name+"TEMPS_MINI_PREMIER_NB_OK "+String.valueOf(TEMPS_MINI_PREMIER_NB_OK)+"\n";
    Name=Name+"SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE "+String.valueOf(SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE)+"\n";
    Name=Name+"SEUIL_W_INST_RELATIVE_6DB "+String.valueOf(SEUIL_W_INST_RELATIVE_6DB)+"\n";
    Name=Name+"SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS "+String.valueOf(SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS)+"\n";
    Name=Name+"SEUIL_W_ATTENTE_RELATIVE_DEMI_TON "+String.valueOf(SEUIL_W_ATTENTE_RELATIVE_DEMI_TON)+"\n";
    Name=Name+"SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON "+String.valueOf(SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON)+"\n";
    Name=Name+"COEFF_RECOUVREMENT_NOTES_SYNCHRONES "+String.valueOf(COEFF_RECOUVREMENT_NOTES_SYNCHRONES)+"\n";
    Name=Name+"SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON "+String.valueOf(SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON)+"\n";
    Name=Name+"SEUIL_TEMPS_NOTES_ASYNCHRONES "+String.valueOf(SEUIL_TEMPS_NOTES_ASYNCHRONES)+"\n";
    Name=Name+"DUREE_MIN_INTERVAL_S "+String.valueOf(SEUIL_DUREE_MIN_INTERVAL_S)+"\n";
    Name=Name+"SEUIL_DISPARITION_NOTE_PREC_S "+String.valueOf(SEUIL_DISPARITION_NOTE_PREC_S)+"\n";
    Name=Name+"SEUIL_APPARITION_HMS_S "+String.valueOf(SEUIL_APPARITION_HMS_S)+"\n";
    Name=Name+"SEUIL_TEMPS_INTERFERENCES_S "+String.valueOf(SEUIL_TEMPS_INTERFERENCES_S)+"\n";
    Name=Name+"SEUIL_MOD2_RELATIVE_FOR_NOTES "+String.valueOf(SEUIL_MOD2_RELATIVE_FOR_NOTES)+"\n";
    Name=Name+"SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS "+String.valueOf(SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS)+"\n";
    Name=Name+"NB_PISTES_MIN_INTERVAL "+String.valueOf(NB_PISTES_MIN_INTERVAL)+"\n";
    Name=Name+"NB_TRACK_VALID_NOTE "+String.valueOf(NB_TRACK_VALID_NOTE)+"\n";
   int sys_exp=           this.jComboBoxsystem_exploitation.getSelectedIndex();
    Name=Name+"system_exploitation "+String.valueOf(sys_exp)+"\n";
    return Name;  
        
    }

    private void openMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openMenuItemActionPerformed
// TODO add your handling code here:
        String Name=GetNomFichierTxt();
        if (Name ==null) return;
        File fileObject;
        try {
            fileObject = new File(Name);
        char data[] = new char[(int) fileObject.length()];
        FileReader filereader;
        try {
            filereader = new FileReader(Name);
        } catch (FileNotFoundException ex) {
            return;
        }
        
        int charsread;
        try {
            charsread = filereader.read(data);
        } catch (IOException ex) {
            return;
        }
        String Parameters= new String(data, 0 , charsread);
        this.getParametersFromString(Parameters); 
     //   System.out.println(Name );
        try {
            filereader.close();
        } catch (IOException ex) {
           
        }
        } finally {
            return;
        }

    }//GEN-LAST:event_openMenuItemActionPerformed

    private void saveMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveMenuItemActionPerformed
// TODO add your handling code here:
      String Name=GetNomFichierTxt();
      if (Name==null) return;
      if (!Name.toLowerCase().endsWith(".txt")) Name+=".txt";
        File fileObject = new File(Name);

        
        FileWriter filewriter;
        try {
            filewriter = new FileWriter(Name);      
        } catch (IOException ex) {
            System.out.println("unable to get filewriter");
            return;
        }
        String data=this.getStringFromParameters();
        try {
            filewriter.write(data);
        } catch (IOException ex) {
            System.out.println("unable to write in file");
        }
        try {
            filewriter.close();
        } catch (IOException ex) {
            System.out.println("unable to close file");
            
        }
    }//GEN-LAST:event_saveMenuItemActionPerformed

    private void jButtonParametresNotesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonParametresNotesActionPerformed
// TODO add your handling code here:
        ParametresNotes parametres_notes=new ParametresNotes(this);
     //   parametres_notes.setParametres(this);
        parametres_notes.setVisible(true);

    }//GEN-LAST:event_jButtonParametresNotesActionPerformed
    
    private void jComboBoxEndianActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxEndianActionPerformed
// TODO add your handling code here:
        this.CHOIX_BIG_ENDIAN=this.jComboBoxEndian.getSelectedIndex();
    }//GEN-LAST:event_jComboBoxEndianActionPerformed
    
    private void jComboBoxsystem_exploitationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxsystem_exploitationActionPerformed
// TODO add your handling code here:
        this.system_exploitation=jComboBoxsystem_exploitation.getSelectedItem().toString();
    }//GEN-LAST:event_jComboBoxsystem_exploitationActionPerformed
    
    private void jButtonFrequencesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonFrequencesActionPerformed
// TODO add your handling code here:
        ChoixFrequences ChoixFrequences=new ChoixFrequences();
        ChoixFrequences.setParametres(this);
        
        this.jButtonAccordeur.setText("Accordeur, LA4 = "+String.valueOf(Math.round(this.F_LA))+"Hertz");
        
    }//GEN-LAST:event_jButtonFrequencesActionPerformed
    
    private void jButtonSound2ScoresActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSound2ScoresActionPerformed
// TODO add your handling code here:
        
        TargetDataLine    line1 = this.getFirstGoodMixerTargetDataline();
        if (line1==null) {return;}
        //   Line.Info info=line1.getLineInfo();
        //   TargetDataLine.
        try {
            AudioFormat format = line1.getFormat();
            int buffer_size=LGN_BUF*format.getFrameSize();
            F_ECH=format.getSampleRate();
            line1.open(format,buffer_size);// because bytes
            
            // longueur du buffer, 0.5s maxi, en puissance de 2
            double nb_buffer=0.2*F_ECH;
            nb_buffer=Math.floor(Math.log(nb_buffer)/Math.log(2.0));
            nb_buffer=Math.exp(nb_buffer*Math.log(2.0));
            LGN_BUF=(int)Math.round(nb_buffer);
            System.out.println(" F_ECH="+String.valueOf(F_ECH));
            System.out.println(" format="+format.toString());
            
            ContexteFlts Contexte=new ContexteFlts(
                    (float) F_MINI,     // (double),/*= 50,*/
                    (float) F_MAXI,     // (double),/*= 440,*/
                    (float) F_ECH,     // (double),/*= 11025.0,*/
                    (float) F_LA,     // (double),/* FREQUENCE REELLE DU LA = 440.0 */
                    (int) LGN_BUF,   // Word, /* RQ // CONTEXTE.LGN_BUFFER      <= 1024 */
                    
                    (int) NB_CEL_BES,   // Word,/*=2,*/
                    (int) NB_CEL_BUT,   // Word,/*=2,*/
                    (int) NB_FILTRES,   // Byte,/*= 6,*/
                    (double) DELTAF_DERIV,      // (double),/*=0.0025,*/
                    (float) SEUIL_MODU,     // Single,/*= 10.0,*/
                    (float) SEUIL_MOD2_RELATIVE, // Seuil relatif / Module maxi
                    (float) SEUIL_PLUS_DERIVF,  // Single,/* 1.5 */
                    (float) SEUIL_MOINS_DERIVF, // Single,/* 0.5 */
                    
                    (float) TEMPS_MINI_NB_OK,
                    (float) SEUIL_NB_OK_RELATIVE_RETARD_GROUPE,
                    
                    (float) TEMPS_MINI_NB_ATTENTE,
                    (float) SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE,
                    
                    (float) TEMPS_MINI_PREMIER_NB_OK,//unused
                    (float) SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE,//unused
                    
                    
                    (float) SEUIL_W_INST_RELATIVE_6DB,
                    (float) SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS,
                    (float) SEUIL_W_ATTENTE_RELATIVE_DEMI_TON
                    );
            Contexte.set_parametres_regroupement(
                    this.COEFF_RECOUVREMENT_NOTES_SYNCHRONES,
                    this.SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON,
                    this.SEUIL_TEMPS_NOTES_ASYNCHRONES,
                    this.SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON);
            Contexte.F_MAXI_A_GARDER=this.F_MAXI_A_GARDER;
            glob_Contexte=Contexte;
//            System.out.println(info);
            System.out.println(format);
            if (line1.isOpen()) {
                line1.close();
                
            }
            if (( format.getEncoding() !=Encoding.PCM_SIGNED)&&(format.getEncoding() !=Encoding.PCM_UNSIGNED)) {
                System.out.println("Bad Encoding:"+format.getEncoding().toString());
                return;
            }
            if (( format.getSampleSizeInBits() !=16)&&( format.getSampleSizeInBits() !=8)) {
                System.out.println("Bad Sample Size:"+String.valueOf(format.getSampleSizeInBits()));
                return;
            }
            
//            final TargetDataLine line1 = (TargetDataLine)
//            AudioSystem.getLine(info);
            System.out.println("Opening Line : "+line1.toString());
            Sound2Scores D=new Sound2Scores(this,Contexte,line1,format,400,400);
            //     line1.start();
            //     Sound2ScoresThread captureThread = new Sound2ScoresThread(this,Contexte,line1,format);
            //     captureThread.start();
        } catch (LineUnavailableException e) {
            System.out.println("Line unavailable: " + e.toString());
            System.exit(-2);
        }
    }//GEN-LAST:event_jButtonSound2ScoresActionPerformed
    
    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_aboutMenuItemActionPerformed
    public TargetDataLine getFirstGoodMixerTargetDataline(){
        TargetDataLine line1;
        if (this.system_exploitation=="linux") {
            int ii=0,good_ii=-1;
            int jj=0,good_jj=-1;
            boolean line_found=false;
            Line[] allTargetLines=null;
            Line.Info[] allTLineInfos=null;
            Mixer mixer=null;
            
            try {
                
                System.out.println("Searching Target DataLine on Mixer");
                final Mixer.Info[] allMixer = AudioSystem.getMixerInfo();
                while ((ii<allMixer.length)&&(line_found!=true)) {
                    mixer = AudioSystem.getMixer(allMixer[ii]);
                    try {
                        allTargetLines = mixer.getTargetLines();
                        allTLineInfos =
                                mixer.getTargetLineInfo();
                        for (jj=0; (jj<allTLineInfos.length)&&(line_found!=true);) {
                            Line.Info line1_info=allTLineInfos[jj];
                            try {
                                
                                line1 = (TargetDataLine)
                                mixer.getLine( allTLineInfos[jj] );
                                //    line_found=true;
                                System.out.println("  Found one TargetDataLine usable");
                                good_jj=jj;
                                good_ii=ii;
                            } catch(ClassCastException cce) {
                                // proceed to next Line
                            }
                            jj++;
                        }
                    } catch(LineUnavailableException lue) {
                        System.out.println("  LineUnavailable Exception!...");
                        lue.printStackTrace();
                    }
                    ii++;
                }
                if (good_jj==-1) {
                    System.out.println("BAD : NO TargetDataLine Founded");
                    return null;
                }
                System.out.println("OK : TargetDataLine Founded, getting it");
                line1 = (TargetDataLine)
                AudioSystem.getMixer(allMixer[good_ii]).getLine( allTLineInfos[good_jj] );
            } catch (LineUnavailableException e) {
                System.out.println("Line unavailable: " + e.toString());
                return null;
            }
        } else {
            AudioFormat	audioFormat = new AudioFormat(
                    AudioFormat.Encoding.PCM_SIGNED,
                    44100.0F, 16, 2, 4, 44100.0F, true);
            
                /* Now, we are trying to get a TargetDataLine. The
                   TargetDataLine is used later to read audio data from it.
                   If requesting the line was successful, we are opening
                   it (important!).
                 */
            DataLine.Info	info = new DataLine.Info(TargetDataLine.class, audioFormat);
            line1 = null;
            try {
                line1 = (TargetDataLine) AudioSystem.getLine(info);
                line1.open(audioFormat);
            } catch (LineUnavailableException e) {
                System.out.println("unable to get a recording line");
                e.printStackTrace();
                System.exit(1);
            }
        }
        return line1;
    }
    private void jButtonAccordeurActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAccordeurActionPerformed
// TODO add your handling code here:
        TargetDataLine    line1 = this.getFirstGoodMixerTargetDataline();
        if (line1==null) {return;}
        //   Line.Info info=line1.getLineInfo();
        //   TargetDataLine.
        try {
            AudioFormat format = line1.getFormat();
            int buffer_size=LGN_BUF*format.getFrameSize();
            F_ECH=format.getSampleRate();
            line1.open(format,buffer_size);// because bytes
            
            // longueur du buffer, 0.5s maxi, en puissance de 2
            double nb_buffer=0.5*F_ECH;
            nb_buffer=Math.floor(Math.log(nb_buffer)/Math.log(2.0));
            nb_buffer=Math.exp(nb_buffer*Math.log(2.0));
            LGN_BUF=(int)Math.round(nb_buffer);
            System.out.println(" F_ECH="+String.valueOf(F_ECH));
            System.out.println(" format="+format.toString());
            
            ContexteFlts Contexte=new ContexteFlts(
                    (float) F_MINI,     // (double),/*= 50,*/
                    (float) F_MAXI,     // (double),/*= 440,*/
                    (float) F_ECH,     // (double),/*= 11025.0,*/
                    (float) F_LA,     // (double),/* FREQUENCE REELLE DU LA = 440.0 */
                    (int) LGN_BUF,   // Word, /* RQ // CONTEXTE.LGN_BUFFER      */
                    
                    (int) NB_CEL_BES,   // Word,/*=2,*/
                    (int) NB_CEL_BUT,   // Word,/*=2,*/
                    (int) NB_FILTRES,   // Byte,/*= 6,*/
                    (double) DELTAF_DERIV,      // (double),/*=0.0025,*/
                    (float) SEUIL_MODU,     // Single,/*= 10.0,*/
                    (float) SEUIL_MOD2_RELATIVE, // Seuil relatif / Module maxi
                    (float) SEUIL_PLUS_DERIVF,  // Single,/* 1.5 */
                    (float) SEUIL_MOINS_DERIVF, // Single,/* 0.5 */
                    
                    (float) TEMPS_MINI_NB_OK,
                    (float) SEUIL_NB_OK_RELATIVE_RETARD_GROUPE,
                    
                    (float) TEMPS_MINI_NB_ATTENTE,
                    (float) SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE,
                    
                    (float) TEMPS_MINI_PREMIER_NB_OK,//unused
                    (float) SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE,//unused
                    
                    
                    (float) SEUIL_W_INST_RELATIVE_6DB,
                    (float) SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS,
                    (float) SEUIL_W_ATTENTE_RELATIVE_DEMI_TON
                    );
            Contexte.set_parametres_regroupement(
                    this.COEFF_RECOUVREMENT_NOTES_SYNCHRONES,
                    this.SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON,
                    this.SEUIL_TEMPS_NOTES_ASYNCHRONES,
                    this.SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON);
            Contexte.F_MAXI_A_GARDER=this.F_MAXI_A_GARDER;
            glob_Contexte=Contexte;
            
//            System.out.println(info);
            System.out.println(format);
            if (line1.isOpen()) {
                line1.close();
                
            }
            if (( format.getEncoding() !=Encoding.PCM_SIGNED)&&(format.getEncoding() !=Encoding.PCM_UNSIGNED)) {
                System.out.println("Bad Encoding:"+format.getEncoding().toString());
                return;
            }
            if (( format.getSampleSizeInBits() !=16)&&( format.getSampleSizeInBits() !=8)) {
                System.out.println("Bad Sample Size:"+String.valueOf(format.getSampleSizeInBits()));
                return;
            }

            
//            final TargetDataLine line1 = (TargetDataLine)
//            AudioSystem.getLine(info);
            System.out.println("Opening Line : "+line1.toString());
            Accordeur D=new Accordeur(this,Contexte,line1,format,400,400);
            //     line1.start();
            //     AccordeurThread captureThread = new AccordeurThread(this,Contexte,line1,format);
            //     captureThread.start();
        } catch (LineUnavailableException e) {
            System.out.println("Line unavailable: " + e.toString());
            System.exit(-2);
        }
        
    }//GEN-LAST:event_jButtonAccordeurActionPerformed
    
    private void jButtonParametresActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonParametresActionPerformed
        Parametres parametres=new Parametres();
        parametres.setParametres(this);
        parametres.setVisible(true);
        this.jButtonAccordeur.setText("Accordeur, LA4 = "+String.valueOf(Math.round(this.F_LA))+"Hertz");
        
// TODO add your handling code here:
    }//GEN-LAST:event_jButtonParametresActionPerformed
    public short BigEndianToShort(byte[] b) {
        short d ;
        d = (short) (b[1]*256 + (b[0] & 0xFF));
        return d;
    }
    public void Conversion16BitsSignedBigEndianToShort(short [] d, byte[] b,int framesize) {
        int k=0;
        int LGN_BUF=d.length;
        int lb=b.length;
        int i;
        for(i=0;i<LGN_BUF;i++) {
            
            d[i] = (short) (b[k+1]*256 + (b[k] & 0xFF));
            k+=framesize;
        }
    }
    public void Conversion16BitsSignedLittleEndianToShort(short [] d, byte[] b,int framesize) {
        int k=0;
        int LGN_BUF=d.length;
        for(int i=0;i<LGN_BUF;i++) {
            d[i] = (short) (b[k]*256 + (b[k+1] & 0xFF));
            k+=framesize;
        }
    }
    public void Conversion16BitsUnsignedBigEndianToShort(short [] d, byte[] b,int framesize) {
        int k=0;
        int LGN_BUF=d.length;
        int lb=b.length;
        int i,n;
        for(i=0;i<LGN_BUF;i++) {
            n=(b[k+1]<<8) | (b[k] & 0xff);
            n&=0xffff;
            n-=32768;
            d[i] = (short) n;
            k+=framesize;
        }
    }
    public void Conversion8BitsUnsignedToShort(short [] d, byte[] b,int framesize) {
        int k=0;
        int LGN_BUF=d.length;
        int lb=b.length;
        int i,n;
        for(i=0;i<LGN_BUF;i++) {
            n=b[k];
            n&=0xff;
            n-=128;
            d[i] = (short) n;
            k+=framesize;
        }
    }
    public void Conversion8BitsSignedToShort(short [] d, byte[] b,int framesize) {
        int k=0;
        int LGN_BUF=d.length;
        int lb=b.length;
        int i,n;
        for(i=0;i<LGN_BUF;i++) {
            d[i] = (short) b[k];
            k+=framesize;
        }
    }
    
    public void Conversion16BitsUnsignedLittleEndianToShort(short [] d, byte[] b,int framesize) {
        int k=0,n;
        int LGN_BUF=d.length;
        for(int i=0;i<LGN_BUF;i++) {
            n=(b[k]<<8) | ( b[k+1] & 0xff);
            n&=0xffff;
            n-=32768;
            d[i] = (short) n;
            k+=framesize;
        }
    }
    public void ConversionToShort(short [] d, byte[] b,int frame_size,boolean is_big_endian,boolean is_signed,int nb_bytes) {
        if (nb_bytes==2) {
            if (is_signed) {
                //signed 16 bits
                if (is_big_endian) {
                    Conversion16BitsSignedBigEndianToShort(d,b,frame_size)   ;
                } else {
                    Conversion16BitsSignedLittleEndianToShort(d,b,frame_size)   ;
                }
                return;
            }
            //unsigned 16 bits
                if (is_big_endian) {
                    Conversion16BitsUnsignedBigEndianToShort(d,b,frame_size)   ;
                } else {
                    Conversion16BitsUnsignedLittleEndianToShort(d,b,frame_size)   ;
                }
            return;
        }
        if (nb_bytes==1) {
        //8bits data    
                if (is_signed) {
                    Conversion8BitsSignedToShort(d,b,frame_size)   ;
                } else {
                    Conversion8BitsUnsignedToShort(d,b,frame_size)   ;
                }
            return;
        }
        System.out.println("unavailable format in ConversionToShort");
        return;
        
    }
    
    public boolean getBigEndian(int CHOIX_BIG_ENDIAN, AudioFormat format) {
        boolean is_big_endian=true;
        switch(CHOIX_BIG_ENDIAN) {
            case constantes.BIG_ENDIAN:is_big_endian=true;break;
            case constantes.LOW_ENDIAN:is_big_endian=false;break;
            case constantes.FORMAT_ENDIAN:is_big_endian=format.isBigEndian();break;
            default:System.out.print(" Format Endian pas valable");
        }
        return is_big_endian;
    }
    private short[] get_buffer_short(byte[] buffer_byte,AudioFormat format) {
        int nb_channels=format.getChannels();
        int frame_size=format.getFrameSize();
        int nb_bytes=frame_size/nb_channels;
        int l_buffer_short=buffer_byte.length/(frame_size);
        boolean is_big_endian=this.getBigEndian(this.CHOIX_BIG_ENDIAN,format);
        boolean is_signed=format.getEncoding()==Encoding.PCM_SIGNED;
        short [] buffer_short=new short[l_buffer_short];
        ConversionToShort(buffer_short,buffer_byte,frame_size,is_big_endian,is_signed,nb_bytes);
        return buffer_short;
    }
    public String GetNomFichierWav(){
        JFileChooser chooser = new JFileChooser();
        chooser.setCurrentDirectory(new File("."));
        
        chooser.setFileFilter(new javax.swing.filechooser.FileFilter() {
            public boolean accept(File f) {
                return f.getName().toLowerCase().endsWith(".wav")
                || f.isDirectory();
            }
            
            public String getDescription() {
                return "Fichier Wav";
            }
        });
        
        int r = chooser.showOpenDialog(new JFrame());
        if (r == JFileChooser.APPROVE_OPTION) {
            String name = chooser.getSelectedFile().getAbsolutePath();
            System.out.println(name);
            return name;
        } else {
            return null;
        }
        
    }
    public String GetNomFichierTxt(){
        JFileChooser chooser = new JFileChooser();
        chooser.setCurrentDirectory(new File("."));
        
        chooser.setFileFilter(new javax.swing.filechooser.FileFilter() {
            public boolean accept(File f) {
                return f.getName().toLowerCase().endsWith(".txt")
                || f.isDirectory();
            }
            
            public String getDescription() {
                return "Fichier Texte";
            }
        });
        
        int r = chooser.showOpenDialog(new JFrame());
        if (r == JFileChooser.APPROVE_OPTION) {
            String name = chooser.getSelectedFile().getAbsolutePath();
            System.out.println(name);
            return name;
        } else {
            return null;
        }
        
    }

    private void jButtonTestFichiersTesterFichierWavActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonTestFichiersTesterFichierWavActionPerformed
        // lecture du fichier wav
        byte[] samples;
        String Name=GetNomFichierWav();
        if (Name==null) return;
        GetDataWav gd= new GetDataWav(Name);
        samples=gd.getSamples();
        AudioFormat format = gd.getFormat();
        F_ECH=format.getSampleRate();
        short [] buffer_short=get_buffer_short(samples,format);
        final int buffer_size=LGN_BUF*2;
        ContexteFlts Contexte=new ContexteFlts(
                (float) F_MINI,     // (double),/*= 50,*/
                (float) F_MAXI,     // (double),/*= 440,*/
                (float) F_ECH,     // (double),/*= 11025.0,*/
                (float) F_LA,     // (double),/* FREQUENCE REELLE DU LA = 440.0 */
                (int) LGN_BUF,   // Word, /* RQ // CONTEXTE.LGN_BUFFER      <= 1024 */
                
                (int) NB_CEL_BES,   // Word,/*=2,*/
                (int) NB_CEL_BUT,   // Word,/*=2,*/
                (int) NB_FILTRES,   // Byte,/*= 6,*/
                (double) DELTAF_DERIV,      // (double),/*=0.0025,*/
                (float) SEUIL_MODU,     // Single,/*= 10.0,*/
                (float) SEUIL_MOD2_RELATIVE, // Seuil relatif / Module maxi
                (float) SEUIL_PLUS_DERIVF,  // Single,/* 1.5 */
                (float) SEUIL_MOINS_DERIVF, // Single,/* 0.5 */
                
                (float) TEMPS_MINI_NB_OK,
                (float) SEUIL_NB_OK_RELATIVE_RETARD_GROUPE,
                
                (float) TEMPS_MINI_NB_ATTENTE,
                (float) SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE,
                
                (float) TEMPS_MINI_PREMIER_NB_OK,//unused
                (float) SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE,//unused
                
                
                (float) SEUIL_W_INST_RELATIVE_6DB,
                (float) SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS,
                (float) SEUIL_W_ATTENTE_RELATIVE_DEMI_TON
                );
        Contexte.set_parametres_regroupement(
                this.COEFF_RECOUVREMENT_NOTES_SYNCHRONES,
                this.SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON,
                this.SEUIL_TEMPS_NOTES_ASYNCHRONES,
                this.SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON);
         Contexte.F_MAXI_A_GARDER=this.F_MAXI_A_GARDER;
     //   if (this.stocke_data_wav==true) {
          new PlotFiltersAndData(Name,20,20,400,400,buffer_short,Contexte,this.stocke_data_wav).setVisible(true);
     //   }
        //old version    new PlotDataAndNotes("Notes Detectees =f(t)", 500, 500,Contexte,this).setVisible(true);
        new PlotNotes("Notes Detectees =f(t)", 500, 500,Contexte,this,format);
        
    }//GEN-LAST:event_jButtonTestFichiersTesterFichierWavActionPerformed
    
    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        
    }//GEN-LAST:event_formWindowOpened
    
    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AnalyseDeSon().setVisible(true);
            }
        });
    }

 
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JMenuItem contentsMenuItem;
    private javax.swing.JMenuItem copyMenuItem;
    private javax.swing.JMenuItem cutMenuItem;
    private javax.swing.JMenuItem deleteMenuItem;
    private javax.swing.JMenu editMenu;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JButton jButtonAccordeur;
    private javax.swing.JButton jButtonFrequences;
    private javax.swing.JButton jButtonParametres;
    private javax.swing.JButton jButtonParametresNotes;
    private javax.swing.JButton jButtonSound2Scores;
    private javax.swing.JButton jButtonTestFichiers;
    private javax.swing.JComboBox jComboBoxEndian;
    private javax.swing.JComboBox jComboBoxsystem_exploitation;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanelDiapason;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem openMenuItem;
    private javax.swing.JMenuItem pasteMenuItem;
    private javax.swing.JMenuItem saveAsMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    // End of variables declaration//GEN-END:variables
    
}




