/*
 * MyPlayer.java
 *
 * Created on 30 octobre 2006, 14:10
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.util.Iterator;
import java.util.LinkedList;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.DataLine.Info;
import javax.sound.sampled.Line;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.SourceDataLine;


/**
 *
 * @author ygorra
 */
public class MyPlayer {
    
    private AnalyseDeSon sender;
    
    private AudioFormat format;
    
    private float fSampleRate;
    
    private byte[] abData;
    
    private ContexteFlts Contexte;
    
    private min_max_float min_max_n0_n1;
    
    private LinkedList infos_ok;
    public final float attack_s=0.002f;
    public final float decay_s=0.2f;
    
    
    private double taux_hm1=1.0;
    private double taux_hm3=0.0;
    private double taux_hm5=0.0;
    
    private double F_ECH;
    
    private boolean adjust_notes;

    private Interval[] intervals;
    
    
    
    
    public float[] TabEnveloppe(int l,int i_decay) {
        float e_attack=(float)Math.exp(-1.0/(F_ECH*attack_s));
        float e_decay=(float)Math.exp(-1.0/(F_ECH*decay_s));
        int i;
        // generation de l'attaque
        float c_attack=1f;
        float[] t=new float[l];
        i_decay=0; // ici les gars, decay des le debut
        for (i=0;i<l;i++ ) {
            t[i]=(1-c_attack);//*amp;
            c_attack*=e_attack;
        }
        // generation du decay
        float c_decay=1f;
        for (i=i_decay;i<l;i++ ) {
            t[i]*=c_decay;
            c_decay*=e_decay;
        }
        return t;
        
    }
    public void AddNoteToBuffer(InfoTrack info_ok,float[] buffer_float) {
        double inc;
        if (this.adjust_notes) {inc=(info_ok.f_ajustee/F_ECH);} else                   {inc=(info_ok.f_reelle_super_track/F_ECH);}
        int n_max=buffer_float.length;
        int n0=(int) info_ok.n0_reel_super_track;
        int n1=(int)info_ok.n1_reel_super_track;
        n1=min_max_n0_n1.max_data<n1?(int)min_max_n0_n1.max_data:n1;
        int nf=(int) Math.round(info_ok.n1_reel_super_track+5*decay_s*F_ECH);
        nf=min_max_n0_n1.max_data<nf?(int)min_max_n0_n1.max_data:nf;
        float[] tab_enveloppe=TabEnveloppe(nf-n0+1,n1-n0);//,(float)Math.sqrt(info_ok.better_sum_mod_square));
        double data;
        double phase=0.0;
        int k=n0;
        for(int i=0;i<tab_enveloppe.length;i++) {
            data=phase>=0?1.0:-1.0;
            data*=tab_enveloppe[i];
            phase+=inc;
            if (phase>=0.5) phase-=1.0;
            if ((k>=0)&&(k<buffer_float.length)) {
                buffer_float[k]+=data;
            }
            k++;
        }
    }
  public void AddNoteToBuffer(Interval it,float[] buffer_float) {
        double inc;
        if (it.notes==null) return;
        InfoNote nt=it.notes[0];
        if (this.adjust_notes) {inc=(nt.frequences/F_ECH);} 
        else                   {inc=(nt.frequences/F_ECH);}
        int n_max=buffer_float.length;
        int n0=(int) it.n0;
        int n1=(int)it.n1;
        n1=min_max_n0_n1.max_data<n1?(int)min_max_n0_n1.max_data:n1;
        int nf=(int) Math.round(it.n1+5*decay_s*F_ECH);
        nf=min_max_n0_n1.max_data<nf?(int)min_max_n0_n1.max_data:nf;
        float[] tab_enveloppe=TabEnveloppe(nf-n0+1,n1-n0);//,(float)Math.sqrt(info_ok.better_sum_mod_square));
        double data;
        double phase=0.0;
        int k=n0;
        for(int i=0;i<tab_enveloppe.length;i++) {
            data=phase>=0?1.0:-1.0;
            data*=tab_enveloppe[i];
            phase+=inc;
            if (phase>=0.5) phase-=1.0;
            if ((k>=0)&&(k<buffer_float.length)) {
                buffer_float[k]+=data;
            }
            k++;
        }
    }
  
    private byte[] CreeBufferByte() {
        float[] buffer_float;
        boolean ok;
        InfoTrack info_ok=null;
        min_max_n0_n1= Contexte.get_min_max_n0_n1_reel_groupe(infos_ok);
        if (min_max_n0_n1==null) return null;
        if (min_max_n0_n1.max_data-min_max_n0_n1.min_data<=2) return null;
        min_max_n0_n1.max_data+=5*decay_s*F_ECH;
        buffer_float =new float[(int)Math.round(min_max_n0_n1.max_data+1)];
        Iterator iterator=infos_ok.iterator();
        while (iterator.hasNext()) {
            Object O=iterator.next();
            ok= O!=null;
            if (ok) {
                info_ok=(InfoTrack) O;
                ok=(info_ok.is_a_super_track==true)
                &&(info_ok.nb_tracks_in_super_track>1);
            }
            if (ok) {
                AddNoteToBuffer(info_ok,buffer_float);
            }
        }
        return ConvertToByte(buffer_float,format);
        
        
    }
    private byte[] CreeBufferByte(Interval[] intervals) {
        float[] buffer_float;
        boolean ok;
        Interval it=null;
        if (intervals==null) return null;
           min_max_n0_n1= Contexte.get_min_max_n0_n1_Interval(intervals);
        if (min_max_n0_n1==null) return null;
        if (min_max_n0_n1.max_data-min_max_n0_n1.min_data<=2) return null;
        min_max_n0_n1.max_data+=5*decay_s*F_ECH;
        buffer_float =new float[(int)Math.round(min_max_n0_n1.max_data+1)];
        for(int i=0;i<intervals.length;i++) {
           AddNoteToBuffer(intervals[i],buffer_float);
        }
        return ConvertToByte(buffer_float,format);
        
        
    }
    
    private byte[] ConvertToByte(float[] buffer_float, AudioFormat format) {
        int i,k;
        byte bh,bl;
        int frame_size=format.getFrameSize();
        boolean is_big_endian=sender.getBigEndian(sender.CHOIX_BIG_ENDIAN,format);
        //   is_big_endian=format.isBigEndian();
        int nb_channels=format.getChannels();
        int nb_bytes=frame_size/nb_channels;
        boolean is_signed=format.getEncoding()==format.getEncoding().PCM_SIGNED;
        if (buffer_float==null) return null;
        byte[] buffer_byte=new byte[buffer_float.length*frame_size];
        int min_val=0,max_val=1,demi_val=0,data;
        if (nb_bytes==2) {
            max_val=65535;demi_val=32768;
        }
        if (nb_bytes==1) {
            max_val=255;demi_val=128;
        }
        if (is_signed) {
            max_val-=demi_val;min_val-=demi_val;
        }
        min_max_float min_max_f=new min_max_float(buffer_float);
        echelle_graphique float_2_val=new echelle_graphique(
                0f,1f,
                min_val     ,max_val     ,
                min_max_f.min_data,min_max_f.max_data );
        k=0;
        for (i=0;i<buffer_float.length;i++) {
            data=float_2_val.getPixel(buffer_float[i]);
            if (nb_bytes==2) {
                bl=(byte)(data&0xff);
                bh=(byte) ((data&0xff00)>>8);
                if (is_big_endian) {
                    buffer_byte[k]=bl;
                    buffer_byte[k+1]=bh;
                } else {
                    buffer_byte[k+1]=bl;
                    buffer_byte[k]=bh;
                }
            }
            if (nb_bytes==1) {
                bl=(byte)(i&0xff);
                buffer_byte[k]=bl;
            }
            k+=frame_size;
        }
        return buffer_byte;
    }
    /** Creates a new instance of MyPlayer */
    public MyPlayer(AnalyseDeSon sender_, ContexteFlts Contexte_, AudioFormat format_,LinkedList infos_ok_,boolean adjust_notes_) {
        Line.Info[] info_mix;
        sender=sender_;
        adjust_notes=adjust_notes_;
        Contexte=Contexte_;
        format=format_;
        if (Contexte==null) return;
        infos_ok=infos_ok_;
        if (infos_ok==null) return;
        
        SourceDataLine	line = null;
        boolean OK=false;
        Mixer.Info[] all_mixers_infos=AudioSystem.getMixerInfo();
        for (int i_mixer=0;i_mixer < all_mixers_infos.length;i_mixer++) {
            Mixer.Info info_mixer=all_mixers_infos[i_mixer];
            Mixer mix=AudioSystem.getMixer(info_mixer);
            info_mix=mix.getSourceLineInfo();
            for (int i_line=0;i_line<info_mix.length;i_line++) {
                String s=info_mix[i_line].getLineClass().getName();
                if (s.lastIndexOf("SourceDataLine")>0) {
                    // voici une sourceDataLine;
                    DataLine.Info info_line=(DataLine.Info) info_mix[i_line];
                    AudioFormat[] formats=info_line.getFormats();
                    for(int i_f=0;i_f<formats.length;i_f++) {
                        AudioFormat f=formats[i_f];
                        float SampleRate=f.getSampleRate();
                        AudioFormat.Encoding encoding=f.getEncoding();
                        int sampleSizeInBits=f.getSampleSizeInBits();
                        int nbchannels=f.getChannels();
                        
                        OK=SampleRate==Contexte.F_ECH;
                        if (!OK) {
                            OK=SampleRate==AudioSystem.NOT_SPECIFIED;
                            if (OK ) {SampleRate=Contexte.F_ECH;}
                        }
                        if(OK) {
                            OK=f.getEncoding()==f.getEncoding().PCM_SIGNED;
                            OK=encoding==f.getEncoding().PCM_SIGNED;
                        }
                        if(OK) {
                            
                            OK=sampleSizeInBits==16;
                            if (!OK) {
                                OK=sampleSizeInBits==AudioSystem.NOT_SPECIFIED;
                                if (OK ) {sampleSizeInBits=16;}
                            }
                        }
                        
                        if(OK){
                            OK=(nbchannels==1)||(nbchannels==2);
                            
                            if (!OK) {
                                OK=nbchannels==AudioSystem.NOT_SPECIFIED;
                                if (OK ) {nbchannels=2;}
                            }
                        }
                        if (OK) {
                            boolean is_signed=true;
                            format=new AudioFormat(SampleRate, sampleSizeInBits, f.getChannels(), is_signed, f.isBigEndian());
                            try {
                                line = (SourceDataLine) AudioSystem.getLine(info_line);
                                
                                line.open(format);
                            } catch (LineUnavailableException e) {
                                OK=false;
                            } catch (Exception e) {
                                OK=false;
                            }
                            
                        }
                        if (OK) {// tout va bien, on a trouve une ligne
                            i_f=formats.length;
                            i_line=info_mix.length;
                            i_mixer=all_mixers_infos.length;
                        }
                        
                    }
                    
                }
           /*     Line line_=lines[i_line];
                getLineClass().getName();
                DataLine.Info info_=(Info) line_.getLineInfo();*/
            }
        }
        if (!OK) return;
        DataLine.Info	info = new DataLine.Info(
                SourceDataLine.class,format);
        if (line==null) {
            try {
                line = (SourceDataLine) AudioSystem.getLine(info);
                format=line.getFormat();
                line.open(format);
            } catch (LineUnavailableException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            format=line.getFormat(); // c'est celui la le bon
        }
        this.F_ECH=format.getFrameRate();
        byte[] buffer_byte=CreeBufferByte();
        line.start();
        int n_max=line.getBufferSize();
        n_max=(int)Math.round((float)Math.min(0.1*F_ECH,(float)n_max));
        // forcement un nb entier de trames
        n_max=n_max/format.getFrameSize();
        n_max*=format.getFrameSize();
        // nb de buffers
        int nb_buffer=buffer_byte.length/n_max;
        // le dernier buffer n'est pas forcement plein
        int ofs,n_to_write,nb_writed;
        nb_writed=0;
        for (int i_buffer=0;i_buffer<nb_buffer;i_buffer++) {
            ofs=nb_writed;
            n_to_write=(int) Math.round(Math.min((float)(buffer_byte.length-ofs-1),(float)n_max));
            n_to_write/=format.getFrameSize();
            n_to_write*=format.getFrameSize();
            int	nWritten = line.write(buffer_byte,ofs,n_to_write);
            nb_writed+=nWritten;
        }
        // wait 1 second
        long t_out=System.currentTimeMillis()+1000;
        while (System.currentTimeMillis()<t_out) {};
        line.stop();
        line.close();
    }
    public MyPlayer(AnalyseDeSon sender_, ContexteFlts Contexte_, AudioFormat format_,Interval[] intervals_,boolean adjust_notes_) {
        Line.Info[] info_mix;
        sender=sender_;
        adjust_notes=adjust_notes_;
        Contexte=Contexte_;
        format=format_;
        if (Contexte==null) return;
        intervals=intervals_;
        if (intervals==null) return;
        
        SourceDataLine	line = null;
        boolean OK=false;
        Mixer.Info[] all_mixers_infos=AudioSystem.getMixerInfo();
        for (int i_mixer=0;i_mixer < all_mixers_infos.length;i_mixer++) {
            Mixer.Info info_mixer=all_mixers_infos[i_mixer];
            Mixer mix=AudioSystem.getMixer(info_mixer);
            info_mix=mix.getSourceLineInfo();
            for (int i_line=0;i_line<info_mix.length;i_line++) {
                String s=info_mix[i_line].getLineClass().getName();
                if (s.lastIndexOf("SourceDataLine")>0) {
                    // voici une sourceDataLine;
                    DataLine.Info info_line=(DataLine.Info) info_mix[i_line];
                    AudioFormat[] formats=info_line.getFormats();
                    for(int i_f=0;i_f<formats.length;i_f++) {
                        AudioFormat f=formats[i_f];
                        float SampleRate=f.getSampleRate();
                        AudioFormat.Encoding encoding=f.getEncoding();
                        int sampleSizeInBits=f.getSampleSizeInBits();
                        int nbchannels=f.getChannels();
                        
                        OK=SampleRate==Contexte.F_ECH;
                        if (!OK) {
                            OK=SampleRate==AudioSystem.NOT_SPECIFIED;
                            if (OK ) {SampleRate=Contexte.F_ECH;}
                        }
                        if(OK) {
                            OK=f.getEncoding()==f.getEncoding().PCM_SIGNED;
                            OK=encoding==f.getEncoding().PCM_SIGNED;
                        }
                        if(OK) {
                            
                            OK=sampleSizeInBits==16;
                            if (!OK) {
                                OK=sampleSizeInBits==AudioSystem.NOT_SPECIFIED;
                                if (OK ) {sampleSizeInBits=16;}
                            }
                        }
                        
                        if(OK){
                            OK=(nbchannels==1)||(nbchannels==2);
                            
                            if (!OK) {
                                OK=nbchannels==AudioSystem.NOT_SPECIFIED;
                                if (OK ) {nbchannels=2;}
                            }
                        }
                        if (OK) {
                            boolean is_signed=true;
                            format=new AudioFormat(SampleRate, sampleSizeInBits, f.getChannels(), is_signed, f.isBigEndian());
                            try {
                                line = (SourceDataLine) AudioSystem.getLine(info_line);
                                
                                line.open(format);
                            } catch (LineUnavailableException e) {
                                OK=false;
                            } catch (Exception e) {
                                OK=false;
                            }
                            
                        }
                        if (OK) {// tout va bien, on a trouve une ligne
                            i_f=formats.length;
                            i_line=info_mix.length;
                            i_mixer=all_mixers_infos.length;
                        }
                        
                    }
                    
                }
           /*     Line line_=lines[i_line];
                getLineClass().getName();
                DataLine.Info info_=(Info) line_.getLineInfo();*/
            }
        }
        if (!OK) return;
        DataLine.Info	info = new DataLine.Info(
                SourceDataLine.class,format);
        if (line==null) {
            try {
                line = (SourceDataLine) AudioSystem.getLine(info);
                format=line.getFormat();
                line.open(format);
            } catch (LineUnavailableException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            format=line.getFormat(); // c'est celui la le bon
        }
        this.F_ECH=format.getFrameRate();
        byte[] buffer_byte=CreeBufferByte(intervals);
        line.start();
        int n_max=line.getBufferSize();
        n_max=(int)Math.round((float)Math.min(0.1*F_ECH,(float)n_max));
        // forcement un nb entier de trames
        n_max=n_max/format.getFrameSize();
        n_max*=format.getFrameSize();
        // nb de buffers
        int nb_buffer=buffer_byte.length/n_max;
        // le dernier buffer n'est pas forcement plein
        int ofs,n_to_write,nb_writed;
        nb_writed=0;
        for (int i_buffer=0;i_buffer<nb_buffer;i_buffer++) {
            ofs=nb_writed;
            n_to_write=(int) Math.round(Math.min((float)(buffer_byte.length-ofs-1),(float)n_max));
            n_to_write/=format.getFrameSize();
            n_to_write*=format.getFrameSize();
            int	nWritten = line.write(buffer_byte,ofs,n_to_write);
            nb_writed+=nWritten;
        }
        // wait 1 second
        long t_out=System.currentTimeMillis()+1000;
        while (System.currentTimeMillis()<t_out) {};
        line.stop();
        line.close();
    }
    
}


